package net.wanji.web.service;

import net.wanji.feign.pojo.result.JsonViewObject;
import net.wanji.feign.pojo.vo.*;

import javax.servlet.http.HttpServletRequest;

/**
 * @author duanruiming
 * @date 2023/02/09 10:39
 */
public interface FeignProxyService {

    /**
     * 信号机方案下发-基础方案下发
     *
     * @param schemeSendVO
     * @return
     */
    JsonViewObject schemeSend(SchemeSendVO schemeSendVO);

    /**
     * 计划下发-计划信息、时段信息下发
     *
     * @param planSendVO
     * @return
     */
    JsonViewObject planSend(PlanSendVO planSendVO);

    /**
     * 时间表下发-时间表信息下发
     *
     * @param scheduleSendVO
     * @return
     */
    JsonViewObject scheduleSend(ScheduleSendVO scheduleSendVO);

    /**
     * 相位配时下发-相位参数下发
     *
     * @param phaseTimingSendVO
     * @return
     */
    JsonViewObject phaseTimingSend(PhaseTimingSendVO phaseTimingSendVO);

    /**
     * 灯态控制-路口全红/黄闪/关灯控制/恢复下发
     *
     * @param commandVO
     * @return
     */
    JsonViewObject allRedControl(ControlCommandVO commandVO);

    /**
     * 步进控制-步进控制/恢复下发
     *
     * @param stepControlVO
     * @return
     */
    JsonViewObject stepControl(StepControlVO stepControlVO);

    /**
     * 恢复时间表-恢复路口时间表下发
     *
     * @param code
     * @return
     * @throws Exception
     */
    JsonViewObject recoverSchedule(String code) throws Exception;

    /**
     * 锁定控制-相位锁定/解锁下发
     *
     * @param lockControlVO
     * @return
     */
    JsonViewObject lockControl(LockControlVO lockControlVO);

    /**
     * 相位差下发
     *
     * @param httpServletRequest
     * @return
     */
    JsonViewObject phaseDiffSend(HttpServletRequest httpServletRequest);
}
